//-----------------------------------------------------------------------
// 打音順番当てゲーム  for ROBOT ENGINEERS TRAINING SEMINAR
// 　　　　　　　　　　　STARTボタン…低音　SWボタン…高音
//-----------------------------------------------------------------------
// Copyright (C) 2018  Takao Satoh
//-----------------------------------------------------------------------

#define NOTE_B2  123
#define NOTE_C3  131
#define NOTE_CS3 139
#define NOTE_D3  147
#define NOTE_DS3 156
#define NOTE_E3  165
#define NOTE_F3  175
#define NOTE_FS3 185
#define NOTE_G3  196
#define NOTE_GS3 208
#define NOTE_A3  220
#define NOTE_AS3 233
#define NOTE_B3  247
#define NOTE_C4  262
#define NOTE_CS4 277
#define NOTE_D4  294
#define NOTE_DS4 311
#define NOTE_E4  330
#define NOTE_F4  349
#define NOTE_FS4 370
#define NOTE_G4  392
#define NOTE_GS4 415
#define NOTE_A4  440
#define NOTE_AS4 466
#define NOTE_B4  494
#define NOTE_C5  523
#define NOTE_CS5 554
#define NOTE_D5  587
#define NOTE_DS5 622
#define NOTE_E5  659
#define NOTE_F5  698
#define NOTE_FS5 740
#define NOTE_G5  784
#define NOTE_GS5 831
#define NOTE_A5  880
#define NOTE_AS5 932
#define NOTE_B5  988
#define NOTE_C6  1047
#define NOTE_CS6 1109
#define NOTE_D6  1175
#define NOTE_DS6 1245
#define NOTE_E6  1319
#define NOTE_F6  1397
#define NOTE_FS6 1480
#define NOTE_G6  1568
#define NOTE_GS6 1661
#define NOTE_A6  1760
#define NOTE_AS6 1865
#define NOTE_B6  1976
#define NOTE_C7  2093
#define NOTE_CS7 2217
#define NOTE_D7  2349
#define NOTE_DS7 2489
#define NOTE_E7  2637

//ライブラリを取り込む
//#include <Tone.h>
#include <TM1617.h>
#include <Switch.h>
#define START st.isPressed()
#define SW sw.isPressed()
#define ON true
#define OFF false
#define SPK A2
#define CLK 13
#define DIO 11
#define STB 2
Button st = Button(8,BUTTON_PULLUP);
Button sw = Button(4,BUTTON_PULLUP);
TM1617 tm1617(CLK, DIO, STB);

// 7 segment DIGIT
//  A
// F B
//  G
// E C
//  D DP

//  EDCG XABF
//  8421 8421
//A 1011 0111 0xb 7
//b 1111 0001 0xf 1
//C 1100 0101 0xc 5
//d 1111 0010 0xf 2
//E 1101 0101 0xd 5
//F 1001 0101 0x9 5
//G 1110 0101 0xe 5

//  EDCG XABF       EDCG XABF
//  8421 8421       8421 8421
//ﾗ 0011 0100 0x3 4 0000 0000 0x0 0
//ｼ 0001 0100 0x1 4 0110 0010 0x6 2
//ﾄﾞ1001 0001 0x9 1 0000 0011 0x0 3
//ﾚ 1110 0001 0xe 1 0000 0000 0x0 0
//ﾐ 0101 0100 0x5 4 0000 0000 0x0 0
//ﾌｧ0010 0110 0x2 6 0011 0000 0x3 0
//ｿ 0000 0010 0x0 2 0110 0010 0x6 2

static int8_t NoteTabA[] = {
  0xb0, 0x07, //A
  0xf0, 0x01, //b
  0xc0, 0x05, //C
  0xf0, 0x02, //d
  0xd0, 0x05, //E
  0x90, 0x05, //F
  0xe0, 0x05, //G
};

static int8_t NoteTabK[] = {
  0x90, 0x01, 0x00, 0x03, //ﾄﾞ
  0xe0, 0x01, 0x00, 0x00, //ﾚ
  0x50, 0x04, 0x00, 0x00, //ﾐ
  0x20, 0x06, 0x30, 0x00, //ﾌｧ
  0x00, 0x02, 0x60, 0x02, //ｿ
  0x30, 0x04, 0x00, 0x00, //ﾗ
  0x10, 0x04, 0x60, 0x02, //ｼ
};

static uint16_t NoteTag[] = {
  NOTE_C3, 
  NOTE_C4, NOTE_D4, NOTE_E4, NOTE_F4, NOTE_G4, NOTE_A4, NOTE_B4, 
  NOTE_C5, NOTE_D5, NOTE_E5, NOTE_F5, NOTE_G5, NOTE_A5, NOTE_B5, 
  NOTE_C6, NOTE_D6, NOTE_E6, NOTE_F6, NOTE_G6, NOTE_A6, NOTE_B6, 
  NOTE_C7
};

//Tone tone1;
int NoteSeq[100];
int i, Score, Life = 3;

void displayClear(void)
{
  uint8_t addr;

  addr = 0xc0;
  tm1617.start();
  tm1617.writeByte(addr & 0xff);
  tm1617.writeByte((int8_t)0x00);
  tm1617.writeByte((int8_t)0x00);
  tm1617.stop();

  addr = 0xc2;
  tm1617.start();
  tm1617.writeByte(addr & 0xff);
  tm1617.writeByte((int8_t)0x00);
  tm1617.writeByte((int8_t)0x00);
  tm1617.stop();
}

void displayAlpha(char c)
{
  uint8_t addr = 0xc0; //0xc2;

  tm1617.start();
  tm1617.writeByte(addr & 0xff);
  tm1617.writeByte(NoteTabA[2 * (c - 'A')]);
  tm1617.writeByte(NoteTabA[2 * (c - 'A') + 1]);
  tm1617.stop();
}

void displayKana(int index)
{
  index = 4 * (--index % 7);
  uint8_t addr;

  addr = 0xc0;
  tm1617.start();
  tm1617.writeByte(addr & 0xff);
  tm1617.writeByte(NoteTabK[index]);
  tm1617.writeByte(NoteTabK[index + 1]);
  tm1617.stop();

  addr = 0xc2;
  tm1617.start();
  tm1617.writeByte(addr & 0xff);
  tm1617.writeByte(NoteTabK[index + 2]);
  tm1617.writeByte(NoteTabK[index + 3]);
  tm1617.stop();
}

void answer_NG(void)
{
  tone(SPK, NOTE_B3, 225);
  tm1617.displayNum(Score);
  delay(250);
  tone(SPK, NOTE_B3, 500);
  if(--Life <= 0) {
    while(1) {
      delay(500); displayClear();
      delay(500); tm1617.displayNum(Score);
    }
  }
  delay(1500);
}

void answer_OK(void)
{
  tone(SPK, NOTE_E7, 250);
  tm1617.displayNum(Score++);
  delay(250);
  tone(SPK, NOTE_C7, 500);
  tm1617.displayNum(Score);
  if(Score >= 99) {
    delay(250); tone(SPK, NOTE_E7, 250);
    delay(250); tone(SPK, NOTE_C7, 250);
    delay(250); tone(SPK, NOTE_E7, 250);
    delay(250); tone(SPK, NOTE_C7, 500);
    while(1) {
      delay(500); displayClear();
      delay(500); tm1617.displayNum(Score);
    }
  }
  delay(1500);
}

void submit_tone(int note, int code, int dur)
{
  tone(SPK, NoteTag[note], dur);
  displayKana(code);
  delay(dur);
}

void check_beat(int low, int high, int len)
{
  int i = 0;

  while(i < len) {
    if(START == ON) {
      displayKana(low);
      while(START == ON) {
        tone(SPK, NoteTag[low], 50);  delay(25);
      }
      if(NoteSeq[i] != low) {
         answer_NG();  return;
      }
      displayClear(); i++;
    } else if(SW == ON) {
      displayKana(high);
      while(SW == ON) {
        tone(SPK, NoteTag[high], 50);  delay(25);
      }
      if(NoteSeq[i] != high) {
         answer_NG();  return;
      }
      displayClear(); i++;
    }
    delay(25);
  }
  answer_OK();
}

void setup(void)
{
  tm1617.brightness(2); //マトリクスの明るさを２にする（０−８）
  //tm1617.clearDisplay();
  displayClear();
  while(!START == ON)  delay(100);
  randomSeed(millis());
  //tone1.begin(SPK);

//       CDE
//       CDEFG
//       CDEFGA
//       CDEFGABC
//     ABCDEFGABCDE
//    GABCDEFGABCDEFG
//  EFGABCDEFGABCDEFGA
//CDEFGABCDEFGABCDEFGABC
//0000000001111111111222
//1234567890123456789012

  tm1617.displayNum(Score);//マトリクスに二桁数字表示をおこなう  
  delay(1500);
}

void loop(void)
{
  int low, high, sum, len;

  sum = low = high = NoteSeq[0] = 0;
  len = min(Score / 3 + 2, 12);

  while(low == high) {
    low = random(8, 16);
    high = random(8, 16);
  }
  if(low > high) {
    i = low;  low = high;  high = i;
  }
  while(sum == NoteSeq[0] * len) {
    for(sum=i=0; i<len; i++) {
      NoteSeq[i] = random(2) ?  low :  high;
      sum += NoteSeq[i];
    }
  }
  for(i=0; i<len; i++) {
    submit_tone(NoteSeq[i], NoteSeq[i], 450);
    delay(50);
  }
  displayClear();

  check_beat(low, high, len);
}

