#include <drv8853.h>
#include <Wire.h>
#include <Adafruit_TCS34725.h>
#include <TM1617.h>
#include <Switch.h>
#define START st.isPressed()
#define ON true
#define OFF false
#define SPK A2
#define CLK 13
#define DIO 11
#define STB 2
#define COLOR tcs.COLOR()
#define BLACK tcs.BLACK() / 10
MOTOR motor1(MC1);
MOTOR motor2(MC2);
Button st = Button(8,BUTTON_PULLUP);
TM1617 tm1617(CLK, DIO, STB);
Adafruit_TCS34725 tcs = Adafruit_TCS34725(TCS34725_INTEGRATIONTIME_24MS, TCS34725_GAIN_16X);

void setup(){
    while(!START == ON){
    }
    tone(SPK,440,100);
    delay(500);
    tm1617.brightness(2);
    tm1617.clearDisplay();
}

void loop(){
    tm1617.displayNum(COLOR / 10);
    
    if (BLACK < 10){
      //白なら前進
        motor1.rotate(50);
        motor2.rotate(50);
    }
    else if (COLOR > 330 || COLOR < 30){
      //赤なら止まる（赤から動かない）
        motor1.rotate(0);
        motor2.rotate(0);
        delay(1000); //適当な時間
    }
    else if (COLOR > 100 && COLOR < 180){
      //緑なら１回転する
        motor1.rotate(50);
        motor2.rotate(-50);
        delay(1500); //回転時間
    }
    else if (COLOR > 190 && COLOR < 250){
      //青なら１秒間止まって前進する
        motor1.rotate(0);
        motor2.rotate(0);
        delay(1000); //止まる時間
        motor1.rotate(50);
        motor2.rotate(50);
        delay(1000); //青から脱出する時間
    }
}
